Tickit::RectSet(3pm)

NAME
"Tickit::RectSet" - store a set of rectangular regions

DESCRIPTION
Objects in this class store a set of rectangular regions. The object tracks which areas are covered, to ensure that overlaps are avoided, and that neighbouring regions are merged where possible. The order in which they are added is not important.

New regions can be added using the "add" method. The "rects" method returns a list of non-overlapping Tickit::Rect regions, in top-to-bottom, left-to-right order.

CONSTRUCTOR

  new
   $rectset = Tickit::RectSet->new

Returns a new "Tickit::RectSet" instance, initially empty.

METHODS

  rects
   @rects = $rectset->rects

Returns a list of the covered regions, in order first top to bottom, then left to right.

  add
   $rectset->add( $rect )

Adds the region covered by $rect to the stored region list.

  subtract
   $rectset->subtract( $rect )

Removes any covered region that intersects with $rect from the stored region list.

  clear
   $rectset->clear

Remove all the regions from the set.

  intersects
   $bool = $rectset->intersects( $rect )

Returns true if $rect intersects with any region in the set.

  contains
   $bool = $rectset->contains( $rect )

Returns true if $rect is entirely covered by the regions in the set. Note that it may be that the rect requires two or more regions in the set to completely cover it.

AUTHOR
Paul Evans <leonerd@leonerd.org.uk>